
// ==================================================== //

public stock const HOST[] = "";
public stock const USER[] = "";
public stock const PASSWORD[] = "";
public stock const DB[] = "";

// Координаты сообщения
const Float:HUD_X = -1.0;
const Float:HUD_Y = 0.3;
const Float:HUD_TIME = 3.0;		// время жизни худа

// ==================================================== //

#include <amxmodx>
#include <sqlx>
#include <gamecms5>

const QUERY_LENGTH = 4096;


#pragma reqlib mysql
#if !defined AMXMODX_NOAUTOLOAD
#pragma loadlib mysql
#endif


new g_szQuery[QUERY_LENGTH], Handle:g_hSql = Empty_Handle;


public plugin_end()
{
	if (g_hSql != Empty_Handle) {
		SQL_FreeHandle(g_hSql);
	}
}

public plugin_init()
{
	register_plugin("[CMS] personal greeting", "1.0.0", "Emma Jule & Lil Skeezy", .url = "vk.com/topamxx");
	
	
	if (!SQL_SetAffinity("mysql")) {
		set_fail_state("Can't user 'MySQL'. Check modules.ini");
	}
}

public plugin_cfg()
{
	__sql_init();
}

__sql_init()
{
	if (~cmsapi_get_api_status() & UseGameCms)
	{
		set_fail_state("Необходим рабочий плагин GameCMS_API");
	}
	
	g_hSql = SQL_MakeDbTuple(HOST, USER, PASSWORD, DB);
	SQL_SetCharset(g_hSql, "utf8");
	
	new error[256], errorNum, Handle:g_hConnection = Empty_Handle;
	g_hConnection = SQL_Connect(g_hSql, errorNum, error, charsmax(error));
	
	if (errorNum)
	{
		SQL_FreeHandle(g_hSql);
		SQL_FreeHandle(g_hConnection);
		
		set_fail_state("[PG] Init SQL Error: %s (%i)", error, errorNum);
	}
	
	formatex(g_szQuery, charsmax(g_szQuery), "CREATE TABLE IF NOT EXISTS `nf__meeting` (`id` INT NOT NULL AUTO_INCREMENT, `signature` VARCHAR(128) NOT NULL, `color` VARCHAR(12) NOT NULL DEFAULT '0 160 30', `user_id` INT NOT NULL, PRIMARY KEY (`id`));");
	{
		if (!SQL_SimpleQuery(g_hConnection, g_szQuery, error, charsmax(error)))
			set_fail_state("[PG] Init SQL Error: %s", error);
	}
	
	SQL_FreeHandle(g_hConnection);
}

public OnAPIMemberConnected(id, memberId)
{
	// if (is_user_bot(id) || is_user_hltv(id))
		// return;
	
	new aData[1];
	aData[0] = memberId;
	{
		// чтобы он сам ее видел
		set_task(1.0, "load_data", id, aData, sizeof(aData));
	}
}

public load_data(aData[1], id)
{
	if (!is_user_connected(id)) {
		return;
	}
	
	formatex(g_szQuery, charsmax(g_szQuery), "SELECT signature, color FROM `nf__meeting` WHERE user_id = '%i' LIMIT 1", aData[0]);
	{
		new eData[1];
		eData[0] = id;
		{
			SQL_ThreadQuery(g_hSql, "print_greeting", g_szQuery, eData, sizeof(eData));
		}
	}
}

public print_greeting(failState, Handle:query, error[], errorNum, eData[], dataSize)
{
	if (failState)
	{
		log_to_file("personal_greeting.log", "[PG] Data SQL Error: %s (%i)", error, errorNum);
		return;
	}

	if (!SQL_MoreResults(query)) {
		return;
	}
	
	new szText[128], szColor[12], eColor[3][4];
	SQL_ReadResult(query, SQL_FieldNameToNum(query, "signature"), szText, charsmax(szText));
	replace_string(szText, charsmax(szText), "@", fmt("%n", eData[0]));
	
	SQL_ReadResult(query, SQL_FieldNameToNum(query, "color"), szColor, charsmax(szColor));
	parse(szColor, eColor[0], 3, eColor[1], 3, eColor[2], 3);
	
	set_dhudmessage(str_to_num(eColor[0]), str_to_num(eColor[1]), str_to_num(eColor[2]), -1.0, 0.3, 2, 3.0, HUD_TIME, 0.03, 0.4);
	show_dhudmessage(0, szText);
	
	// server_print(szText);
}

